package net.minecraft.src;

import java.io.File;
import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Random;

import net.minecraft.client.Minecraft;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.GL11;

// SDK
public class mod_SdkUtility extends BaseMod
{
    public static Block blockGrinder;
    
    public static final Item itemGoldCoin = (new Item(2509)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("goldCoin");
    public static final Item itemLightometer = (new Item(2510)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("lightometer");
    public static final Item itemNightvisionGoggles = (new ItemArmor(2513, -1, ModLoader.AddArmor("nightvision"), 0)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("nightvisionGoggles");
    public static final Item itemScubaTank = (new ItemArmor(2521, -1, ModLoader.AddArmor("scubaTank"), 1)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("scubaTank");
    public static final Item itemParachute = (new SdkItemParachute(2523, ModLoader.AddArmor("parachute"))).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("parachute");
    
    // Properties
	private static int parachuteKey = Keyboard.KEY_P;
	private static int nightvisionKey = Keyboard.KEY_N;
	private static int blockIdGrinder = 120;
	
	private static boolean parachuteKeyDown = false;
	private static boolean nightvisionKeyDown = false;
	
	public static boolean nightvisionEnabled = false;
	
	public static Random random = new Random();
	
	static
    {
    	loadProperties();
    	initBlocks();
    }
    
    private static void loadProperties()
    {
    	Properties properties = new Properties();
    	try
    	{
    		String propertiesPath = mod_SdkUtility.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath();
    		propertiesPath = propertiesPath.substring(0, propertiesPath.lastIndexOf('/') + 1);
    		propertiesPath += "mod_SdkUtility.properties";
    		
    		properties.load(new FileInputStream(propertiesPath));
    		String property;
    		
    		property = properties.getProperty("parachuteKey");
    		int tempParachuteKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempParachuteKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding parachute key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			parachuteKey = tempParachuteKey;
    		}
    		
    		property = properties.getProperty("nightvisionKey");
    		int tempNightvisionKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempNightvisionKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding nightvision key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			nightvisionKey = tempNightvisionKey;
    		}
    		
    		property = properties.getProperty("blockIdGrinder");
    		blockIdGrinder = Integer.parseInt(property.trim());
        }
        catch(Exception e)
        {
        	System.out.println("Error loading properties.");
			e.printStackTrace();
        }
    }
    
    private static void initBlocks()
    {
    	blockGrinder = (new SdkBlockGrinder(blockIdGrinder, ModLoader.getUniqueSpriteIndex("/terrain.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).func_20012_a("blockGrinder");
    }
	
	public mod_SdkUtility()
    {
		ModLoader.RegisterBlock(blockGrinder);
		
		ModLoader.AddName(blockGrinder, "Grinder");
		
		ModLoader.AddName(itemGoldCoin, "Gold Coin");
		ModLoader.AddName(itemLightometer, "Lightometer");
		ModLoader.AddName(itemNightvisionGoggles, "Nightvision Goggles");
		ModLoader.AddName(itemScubaTank, "Scuba Tank");
		ModLoader.AddName(itemParachute, "Parachute");
		
		ModLoader.RegisterEntityID(SdkEntityParachute.class, "Parachute", ModLoader.getUniqueEntityId());
		
		ModLoader.RegisterTileEntity(SdkTileEntityGrinder.class, "Grinder");
    }
	
	@Override
	public String Version()
	{
		return "1.2_02v2";
	}
    
	@Override
    public void RegisterAnimation(Minecraft minecraft)
    {
		ModLoader.addAnimation(new SdkTextureLightometerFX(minecraft));
    }
	
	@Override
	public void OSDHook(Minecraft minecraft, boolean menuOpen)
	{
		if(!menuOpen)
			renderNightvisionOverlay(minecraft);
		
		if(minecraft.thePlayer != null && minecraft.thePlayer.inventory != null)
		{
			ItemStack scubaTank = minecraft.thePlayer.inventory.armorItemInSlot(2);
	
	        if(scubaTank != null && scubaTank.itemID == itemScubaTank.shiftedIndex)
	        {
	        	minecraft.thePlayer.air = minecraft.thePlayer.maxAir;
	        }
	        
	        ItemStack nightvisionGoggles = minecraft.thePlayer.inventory.armorItemInSlot(3);
	    	
	        if(nightvisionGoggles == null || nightvisionGoggles.itemID != itemNightvisionGoggles.shiftedIndex)
	        {
	        	nightvisionEnabled = false;
	        }
	        
	        if (minecraft.currentScreen == null)
			{
	            if(!Keyboard.isKeyDown(parachuteKey))
	            {
	            	if(parachuteKeyDown)
	            		handleParachuteKey(minecraft);
	            }
	            
	            parachuteKeyDown = Keyboard.isKeyDown(parachuteKey);
	            
	            if(!Keyboard.isKeyDown(nightvisionKey))
	            {
	            	if(nightvisionKeyDown)
	            		handleNightvisionKey();
	            }
	            
	            nightvisionKeyDown = Keyboard.isKeyDown(nightvisionKey);
	        }
		}
	}

	private void renderNightvisionOverlay(Minecraft minecraft)
	{
		ItemStack itemstack = minecraft.thePlayer.inventory.armorItemInSlot(3);
		if(!minecraft.gameSettings.thirdPersonView && itemstack != null)
        {
        	if(itemstack.itemID == itemNightvisionGoggles.shiftedIndex && nightvisionEnabled)
	        {
	        	renderTextureOverlay(minecraft, "%blur%/misc/nightvision.png", 1F);
	        }
        }
	}

	private void renderTextureOverlay(Minecraft mc, String texturePath, float alpha)
	{
		ScaledResolution scaledresolution = new ScaledResolution(mc.displayWidth, mc.displayHeight);
        int width = scaledresolution.getScaledWidth();
        int height = scaledresolution.getScaledHeight();
        
        GL11.glEnable(3042 /*GL_BLEND*/);
        GL11.glDisable(2929 /*GL_DEPTH_TEST*/);
        GL11.glDepthMask(false);
        GL11.glBlendFunc(770, 771);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, alpha);
        GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture(texturePath));
        Tessellator tessellator = Tessellator.instance;
        tessellator.startDrawingQuads();
        tessellator.addVertexWithUV(0.0D, height, -90D, 0.0D, 1.0D);
        tessellator.addVertexWithUV(width, height, -90D, 1.0D, 1.0D);
        tessellator.addVertexWithUV(width, 0.0D, -90D, 1.0D, 0.0D);
        tessellator.addVertexWithUV(0.0D, 0.0D, -90D, 0.0D, 0.0D);
        tessellator.draw();
        GL11.glDepthMask(true);
        GL11.glEnable(2929 /*GL_DEPTH_TEST*/);
        GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, alpha);
	}

	public void handleParachuteKey(Minecraft minecraft)
	{
		ItemStack itemstack = minecraft.thePlayer.inventory.armorInventory[2];
		if(itemstack != null && itemstack.itemID == itemParachute.shiftedIndex)
		{
			useParachute(itemstack, minecraft.theWorld, minecraft.thePlayer);
			
			Packet200ModLoader packet = new Packet200ModLoader();
			packet.packetType = 0;
			ModLoader.SendPacket(this, packet);
		}
	}
	
	public static void handleNightvisionKey()
	{
		nightvisionEnabled = !nightvisionEnabled;
	}

	@Override
    public void AddRecipes(CraftingManager craftingmanager)
    {
		craftingmanager.addRecipe(new ItemStack(itemGoldCoin, 4), new Object[] {
            "#", Character.valueOf('#'), Item.ingotGold
        });
		craftingmanager.addRecipe(new ItemStack(itemLightometer, 1), new Object[] {
        	" # ", "#X#", " # ", Character.valueOf('#'), Item.ingotIron, Character.valueOf('X'), Item.lightStoneDust
        });
		craftingmanager.addRecipe(new ItemStack(itemNightvisionGoggles, 1), new Object[] {
        	"#X#", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), Item.silk
        });
		craftingmanager.addRecipe(new ItemStack(itemScubaTank, 1), new Object[] {
        	"###", "# #", "###", Character.valueOf('#'), Item.ingotIron
        });
		craftingmanager.addRecipe(new ItemStack(itemParachute, 1), new Object[] {
        	"###", "XYX", "YYY", Character.valueOf('#'), Block.cloth, Character.valueOf('X'), Item.silk, Character.valueOf('Y'), Item.leather
        });
		craftingmanager.addRecipe(new ItemStack(blockGrinder, 1), new Object[] {
        	"###", "#X#", "###", Character.valueOf('#'), Block.cobblestone, Character.valueOf('X'), Item.diamond
        });
    }
	
	@Override
	public void AddRenderer(Map map)
	{
		map.put(SdkEntityParachute.class, new SdkRenderParachute());
	}

	@Override
    public void RegisterTextureOverrides()
    {
        ModLoader.addOverride("/terrain.png", "/sdk/blockGrinder.png", blockGrinder.blockIndexInTexture);
        
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGoldCoin.png", itemGoldCoin.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemLightometer.png", itemLightometer.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemNightvisionGoggles.png", itemNightvisionGoggles.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemScubaTank.png", itemScubaTank.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemParachute.png", itemParachute.iconIndex);
    }
	
	@Override
	public GuiScreen OpenModGUI(EntityPlayer entityplayer, Object obj)
    {
        if(obj instanceof SdkGuiGrinder)
        	return (SdkGuiGrinder)obj;
        else
        	return null;
    }
	
	@Override
	public void AddNetClientHandlerEntities(Map<Integer, Class> map)
	{
		map.put(120, SdkEntityParachute.class);
	}
	
	private void useParachute(ItemStack itemstack, World world, EntityPlayer entityplayer)
	{
		if(!SdkEntityParachute.onGroundOrInWater(world, entityplayer))
    	{
	        itemstack.damageItem(1);
            if(itemstack.stackSize == 0)
            {
            	boolean removed = false;
            	for(int i = 0; i < entityplayer.inventory.armorInventory.length; i++)
            	{
            		if(entityplayer.inventory.armorInventory[i] == itemstack)
            		{
            			entityplayer.inventory.armorInventory[i] = null;
            			removed = true;
            			break;
            		}
            	}
            	
            	if(!removed)
            	{
	            	for(int i = 0; i < entityplayer.inventory.mainInventory.length; i++)
	            	{
	            		if(entityplayer.inventory.mainInventory[i] == itemstack)
	            		{
	            			entityplayer.inventory.mainInventory[i] = null;
	            			removed = true;
	            			break;
	            		}
	            	}
            	}
            }
	        
	        world.playSoundAtEntity(entityplayer, "parachute", 0.5F, 1.0F / (random.nextFloat() * 0.1F + 0.95F));
	        
	        if(!world.multiplayerWorld)
	        {
	        	world.entityJoinedWorld(new SdkEntityParachute(world, entityplayer));
	        }
    	}
	}
}
